<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_IntCodeAttr2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_IntCodeAttr2 extends AbstractStructArrayBase
{
    /**
     * The RoomType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_IntCodeAttr[]
     */
    public $RoomType;
    /**
     * Constructor method for ArrayOfJPSOAP_IntCodeAttr2
     * @uses ArrayOfJPSOAP_IntCodeAttr2::setRoomType()
     * @param \StructType\JPSOAP_IntCodeAttr[] $roomType
     */
    public function __construct(array $roomType = array())
    {
        $this
            ->setRoomType($roomType);
    }
    /**
     * Get RoomType value
     * @return \StructType\JPSOAP_IntCodeAttr[]|null
     */
    public function getRoomType()
    {
        return $this->RoomType;
    }
    /**
     * This method is responsible for validating the values passed to the setRoomType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRoomType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRoomTypeForArrayConstraintsFromSetRoomType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJPSOAP_IntCodeAttr2RoomTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_IntCodeAttr2RoomTypeItem instanceof \StructType\JPSOAP_IntCodeAttr) {
                $invalidValues[] = is_object($arrayOfJPSOAP_IntCodeAttr2RoomTypeItem) ? get_class($arrayOfJPSOAP_IntCodeAttr2RoomTypeItem) : sprintf('%s(%s)', gettype($arrayOfJPSOAP_IntCodeAttr2RoomTypeItem), var_export($arrayOfJPSOAP_IntCodeAttr2RoomTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RoomType property can only contain items of type \StructType\JPSOAP_IntCodeAttr, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RoomType value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_IntCodeAttr[] $roomType
     * @return \ArrayType\ArrayOfJPSOAP_IntCodeAttr2
     */
    public function setRoomType(array $roomType = array())
    {
        // validation for constraint: array
        if ('' !== ($roomTypeArrayErrorMessage = self::validateRoomTypeForArrayConstraintsFromSetRoomType($roomType))) {
            throw new \InvalidArgumentException($roomTypeArrayErrorMessage, __LINE__);
        }
        $this->RoomType = $roomType;
        return $this;
    }
    /**
     * Add item to RoomType value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_IntCodeAttr $item
     * @return \ArrayType\ArrayOfJPSOAP_IntCodeAttr2
     */
    public function addToRoomType(\StructType\JPSOAP_IntCodeAttr $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_IntCodeAttr) {
            throw new \InvalidArgumentException(sprintf('The RoomType property can only contain items of type \StructType\JPSOAP_IntCodeAttr, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RoomType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RoomType
     */
    public function getAttributeName()
    {
        return 'RoomType';
    }
}
